﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="ComboBoxFilteringCheckbox.aspx.cs" Inherits="ComboBoxFilteringCheckbox" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
    <title></title>
</head>
<body>
    <form id="form1" runat="server">
        <telerik:RadScriptManager runat="server" ID="RadScriptManager1"></telerik:RadScriptManager>
        <div>
            <telerik:RadComboBox ID="RadComboBox1" runat="server" CheckBoxes="true" CheckedItemsTexts="DisplayAllInInput" Width="300px"
                DataTextField="Name" DataValueField="ID" OnClientDropDownClosing="OnClientDropDownClosing">
                <HeaderTemplate>
                    <telerik:RadTextBox runat="server" ID="RadTextBox1" Width="100%" ClientEvents-OnLoad="OnLoad">
                    </telerik:RadTextBox>
                </HeaderTemplate>
            </telerik:RadComboBox>
        </div>

        <script type="text/javascript">

            var $T = Telerik.Web.UI;
            var originalFunction = $T.RadComboBox.prototype.highlightAllMatches;
            var textBox;

            function OnLoad(sender, args) {
                var comboBox;

                Sys.Application.add_load(function () {
                    textBox = sender;
                    comboBox = $find("RadComboBox1");
                });

                $telerik.$(sender.get_element()).on("keyup", function (e) {
                    comboBox.highlightAllMatches(sender.get_textBoxValue());
                })
            }

            function OnClientDropDownClosing(sender, args) {
                sender.get_items().forEach(function (item) {
                    item.clearEmTags();
                });
                sender.setAllItemsVisible(true);
                textBox.clear();
            }

            $T.RadComboBox.prototype.highlightAllMatches = function (text) {
                this.set_filter($T.RadComboBoxFilter.Contains);
                originalFunction.call(this, text);
                this.set_filter($T.RadComboBoxFilter.None);
            };

        </script>
    </form>
</body>
</html>
